// Client.java

import Halo.*;
import HaloImpl.*;
import java.io.*;
import java.util.StringTokenizer;

public class Client {

  public static void main(String[] args) {
    // Initialize the ORB.
    org.omg.CORBA.ORB orb = org.omg.CORBA.ORB.init(args,null);

    Nyilvantarto nyilvantarto = NyilvantartoHelper.bind(orb, "/serverPoa", "HalozatiNyilvantarto".getBytes());

    try {
      System.out.println( "Hozzadas:" );
      System.out.println();

      Elem el1 = nyilvantarto.ujSzamGep( "i386" );
      Elem el2 = nyilvantarto.ujNyomtato( true );
      Elem el3 = nyilvantarto.ujSzamGep( "Pentium" );

      el1.mutat();
      System.out.println();

      el2.mutat();
      System.out.println();

      el3.mutat();
      System.out.println();

      String az1 = el1.azon;
      String az2 = el2.azon;
      String az3 = el3.azon;

      nyilvantarto.osszeKapcs( az1, az2 );
      nyilvantarto.osszeKapcs( az2, az3 );
      nyilvantarto.osszeKapcs( az3, az1 );

      System.out.println();
      System.out.println( "Leltar:" );
      System.out.println();

      ElemLista elLista = nyilvantarto.lista();

      for( int i = 0; i < elLista.elemek.length; ++i ) 
      {
        elLista.elemek[ i ].mutat();
        System.out.println();
      }

      System.out.println();
      System.out.println( "Kapcsolatok:" );
      System.out.println();

      for( int i = 0; i < elLista.elemek.length; ++i )
      {
        Elem elem = elLista.elemek[ i ];
        ElemLista kapcs = nyilvantarto.kapcs( elem.azon );

        elem.mutat();

        if( !kapcs.ures() )
        {
          System.out.print( ", kapcs: " );
          kapcs.mutat();
        }

        System.out.println();
      } 

      System.out.println();
      System.out.println( "Ellenorzes:" );
      System.out.println();

      System.out.print( "[" );
      nyilvantarto.leker( az1 ).mutat();
      System.out.print( "] es [" );
      nyilvantarto.leker( az2 ).mutat(); 
      System.out.println( "] kozott " 
          + ( nyilvantarto.vanKapcs( az1, az2 ) ? "VAN" : "NINCS" ) 
          + " kapcsolat!"
        );
    }
    catch(HibasAzonosito e) {
      System.out.println( "Hibas azonosito!" );
    }
    catch(HibasKapcsolat e) {
      System.out.println( "Hibas kapcsolat!" );
    }
    catch(Exception e) {
      e.printStackTrace();
      System.out.println(e);
    }
  }
}
